import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;

public class View extends JPanel implements Observer
{
  private Model model;

  // Bob the Builder this shit
  public View(Model model, Handler handler)
  {
    // Hook up this observer so that it will be notified when the model
    // changes.
    this.model = model;
    model.addObserver(this);
    this.addMouseMotionListener(handler);
    this.addMouseListener(handler);
  }

  /**
  * Update with data from the model.
  */
  public void update(Object observable)
  {
    revalidate();
    repaint();
  }
  
  public void paintComponent(Graphics g)
  {
    Graphics gtemp = (Graphics2D) g;
    ArrayList<Thingy> thingies = m.getThingies();
    
    for (Thingy t: thingies)
    {
      ArrayList<Point> points = t.getPoints();
      gtemp.setColor(points.get(0).getColour());
      gtemp.setStroke(new BasicStroke(p.getThiccness(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
      
      if ((points.size() ==  1))
      {
        gtemp.drawLine(points.get(0).x, points.get(0).y, points.get(0).x, points.get(0).y);
      }
      else
      {
        for (int i = 1; i < points.size(); i++)
        {
          gtemp.drawLine(points.get(i - 1).x, points.get(i - 1).y, points.get(i).x, points.get(i).y);
        }
      }
    }
  }
}
